"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var store_1 = __importDefault(require("./store"));
var control_data_1 = __importDefault(require("./control_data"));
var control_helper_1 = __importDefault(require("./control_helper"));
var control_changes_1 = __importDefault(require("./control_changes"));
var utils_1 = require("./utils");
var control_initial_1 = __importDefault(require("./control_initial"));
/**
 * @version 1.1.1
 * Sttore
 */
function sttore(states) {
    var st = store_1.default(states);
    var _a = control_data_1.default(st), set = _a.set, confirm = _a.confirm, cancel = _a.cancel, frozen = _a.frozen;
    var init = control_initial_1.default(st).init;
    var _b = control_helper_1.default(st.sthp), helper = _b.helper, helpers = _b.helpers;
    var _c = control_changes_1.default(st), change = _c.change, changes = _c.changes, omit = _c.omit, only = _c.only;
    function self(values) {
        for (var key in values) {
            if (st.has(key)) {
                set(key, values[key]);
            }
        }
        return st.current();
    }
    function restore(to) {
        function restoreHelper() {
            for (var key in st.list()) {
                st.sthp.set(key, '');
                var value = st.list()[key];
                if (utils_1.isSttore(value)) {
                    value.restore();
                }
            }
        }
        function restorePending() {
            st.stpd.clear();
            for (var key in st.list()) {
                var value = st.list()[key];
                if (utils_1.isSttore(value)) {
                    value.cancel();
                }
            }
        }
        if (to === undefined) {
            restoreHelper();
            restorePending();
        }
        if (to === 'helper') {
            restoreHelper();
        }
        if (to === 'pending') {
            restorePending();
        }
    }
    self.set = set;
    self.confirm = confirm;
    self.cancel = cancel;
    self.frozen = frozen;
    self.helper = helper;
    self.helpers = helpers;
    self.change = change;
    self.changes = changes;
    self.init = init;
    self.restore = restore;
    self.omit = omit;
    self.only = only;
    return self;
}
exports.default = sttore;
