"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function store(data) {
    var initial = JSON.stringify(data);
    var st = new Map();
    var stbackup = new Map();
    var stpd = new Map();
    var sthp = new Map();
    for (var key in data) {
        var value = data[key];
        st.set(key, value);
        stbackup.set(key, value);
        sthp.set(key, '');
    }
    function set(key, value) {
        st.set(key, value);
    }
    function has(key) {
        return st.has(key);
    }
    function get(key) {
        return st.get(key);
    }
    function list() {
        var response = {};
        st.forEach(function (value, key) {
            response[key] = value;
        });
        return response;
    }
    function current() {
        var response = {};
        st.forEach(function (value, key) {
            if (stpd.has(key)) {
                response[key] = stpd.get(key);
            }
            else {
                response[key] = value;
            }
        });
        return response;
    }
    return {
        set: set,
        has: has,
        list: list,
        sthp: sthp,
        backup: stbackup,
        get: get,
        stpd: stpd,
        initial: initial,
        current: current,
        st: st
    };
}
exports.default = store;
